diff --git a/yum/packages.py b/yum/packages.py
index 5ef9951..eebeb9d 100644
--- a/yum/packages.py
+++ b/yum/packages.py
@@ -38,6 +38,7 @@ import struct
 from constants import *
 from operator import itemgetter
 
+import urllib
 import urlparse
 urlparse.uses_fragment.append("media")
 from urlgrabber.grabber import URLGrabber, URLGrabError
@@ -53,6 +54,9 @@ except ImportError:
 import pwd
 import grp
 
+# check if rpm has the new weakdeps tags
+_rpm_has_new_weakdeps = hasattr(rpm, 'RPMTAG_ENHANCENAME')
+
 def comparePoEVR(po1, po2):
     """
     Compare two Package or PackageEVR objects.
@@ -106,14 +110,16 @@ def buildPkgRefDict(pkgs, casematch=True):
     return pkgdict
        
 def parsePackages(pkgs, usercommands, casematch=0,
-                  unique='repo-epoch-name-version-release-arch'):
+                  unique='repo-epoch-name-version-release-arch',
+                  pkgdict=None):
     """matches up the user request versus a pkg list:
        for installs/updates available pkgs should be the 'others list' 
        for removes it should be the installed list of pkgs
        takes an optional casematch option to determine if case should be matched
        exactly. Defaults to not matching."""
 
-    pkgdict = buildPkgRefDict(pkgs, bool(casematch))
+    if pkgdict is None:
+        pkgdict = buildPkgRefDict(pkgs, bool(casematch))
     exactmatch = []
     matched = []
     unmatched = []
@@ -130,11 +136,10 @@ def parsePackages(pkgs, usercommands, casematch=0,
                 trylist = pkgdict.keys()
                 # command and pkgdict are already lowered if not casematch
                 # so case sensitive is always fine
-                restring = fnmatch.translate(command)
-                regex = re.compile(restring)
+                regex = misc.compile_pattern(command)
                 foundit = 0
                 for item in trylist:
-                    if regex.match(item):
+                    if regex(item):
                         matched.extend(pkgdict[item])
                         del pkgdict[item]
                         foundit = 1
@@ -223,6 +228,10 @@ class FakeRepository:
     def __str__(self):
         return self.id
 
+    def _ui_id(self):
+        return self.id
+    ui_id = property(fget=lambda self: self._ui_id())
+
 
 #  Goal for the below is to have a packageobject that can be used by generic
 # functions independent of the type of package - ie: installed or available
@@ -243,34 +252,87 @@ class PackageObject(object):
         
     def _ui_envra(self):
         if self.epoch == '0':
-            out = '%s-%s-%s.%s' % (self.name, 
-                                   self.version,
-                                   self.release, 
-                                   self.arch)
+            return self.nvra
         else:
-            out = '%s:%s-%s-%s.%s' % (self.epoch,
-                                      self.name,  
-                                      self.version, 
-                                      self.release, 
-                                      self.arch)
-        return out
+            return self.envra
     ui_envra = property(fget=lambda self: self._ui_envra())
 
     def _ui_nevra(self):
         if self.epoch == '0':
-            out = '%s-%s-%s.%s' % (self.name,
-                                   self.version,
-                                   self.release,
-                                   self.arch)
+            return self.nvra
         else:
-            out = '%s-%s:%s-%s.%s' % (self.name,
-                                      self.epoch,
-                                      self.version,
-                                      self.release,
-                                      self.arch)
-        return out
+            return self.nevra
     ui_nevra = property(fget=lambda self: self._ui_nevra())
 
+    def _ui_evr(self):
+        if self.epoch == '0':
+            return self.vr
+        else:
+            return self.evr
+    ui_evr = property(fget=lambda self: self._ui_evr())
+
+    def _ui_evra(self):
+        if self.epoch == '0':
+            return self.vra
+        else:
+            return self.evra
+    ui_evra = property(fget=lambda self: self._ui_evra())
+
+    def _ui_nevr(self):
+        if self.epoch == '0':
+            return self.nvr
+        else:
+            return self.nevr
+    ui_nevr = property(fget=lambda self: self._ui_nevr())
+
+    def _na(self):
+        return '%s.%s' % (self.name, self.arch)
+    na = property(fget=lambda self: self._na())
+
+    def _vr(self):
+        return '%s-%s' % (self.version, self.release)
+    vr = property(fget=lambda self: self._vr())
+
+    def _vra(self):
+        return '%s-%s.%s' % (self.version, self.release, self.arch)
+    vra = property(fget=lambda self: self._vra())
+
+    def _evr(self):
+        return '%s:%s-%s' % (self.epoch, self.version, self.release)
+    evr = property(fget=lambda self: self._evr())
+
+    def _evra(self):
+        return '%s:%s-%s.%s' % (self.epoch,self.version,self.release, self.arch)
+    evra = property(fget=lambda self: self._evra())
+
+    def _nvr(self):
+        return '%s-%s-%s' % (self.name, self.version, self.release)
+    nvr = property(fget=lambda self: self._nvr())
+
+    def _nvra(self):
+        return '%s-%s-%s.%s' % (self.name, self.version,self.release, self.arch)
+    nvra = property(fget=lambda self: self._nvra())
+
+    def _nevr(self):
+        return '%s-%s:%s-%s' % (self.name, self.epoch,self.version,self.release)
+    nevr = property(fget=lambda self: self._nevr())
+
+    def _nevra(self):
+        return '%s-%s:%s-%s.%s' % (self.name,
+                                   self.epoch, self.version, self.release,
+                                   self.arch)
+    nevra = property(fget=lambda self: self._nevra())
+
+    def _envr(self):
+        return '%s:%s-%s-%s' % (self.epoch,self.name, self.version,self.release)
+    envr = property(fget=lambda self: self._envr())
+
+    def _envra(self):
+        return '%s:%s-%s-%s.%s' % (self.epoch, self.name,
+                                   self.version, self.release,
+                                   self.arch)
+    envra = property(fget=lambda self: self._envra())
+
     def __str__(self):
         return self.ui_envra
 
@@ -411,6 +473,10 @@ class RpmBase(object):
         self.prco['conflicts'] = [] # (name, flag, (e,v,r))
         self.prco['requires'] = [] # (name, flag, (e,v,r))
         self.prco['provides'] = [] # (name, flag, (e,v,r))
+        self.prco['suggests'] = [] # (name, flag, (e,v,r))
+        self.prco['enhances'] = [] # (name, flag, (e,v,r))
+        self.prco['recommends'] = [] # (name, flag, (e,v,r))
+        self.prco['supplements'] = [] # (name, flag, (e,v,r))
         self.files = {}
         self.files['file'] = []
         self.files['dir'] = []
@@ -481,15 +547,14 @@ class RpmBase(object):
             if prcotuple in self._prco_lookup[prcotype]:
                 return 1
 
-        if True: # Keep indentation for patch smallness...
-            # make us look it up and compare
-            (reqn, reqf, (reqe, reqv ,reqr)) = prcotuple
-            if reqf is not None:
-                return self.inPrcoRange(prcotype, prcotuple)
-            else:
-                for (n, f, (e, v, r)) in self.returnPrco(prcotype):
-                    if i18n.str_eq(reqn, n):
-                        return 1
+        # make us look it up and compare
+        (reqn, reqf, (reqe, reqv ,reqr)) = prcotuple
+        if reqf is not None:
+            return self.inPrcoRange(prcotype, prcotuple)
+        else:
+            for (n, f, (e, v, r)) in self.returnPrco(prcotype):
+                if i18n.str_eq(reqn, n):
+                    return 1
 
         return 0
 
@@ -611,15 +676,20 @@ class RpmBase(object):
     dirlist = property(fget=lambda self: self.returnFileEntries(ftype='dir'))
     ghostlist = property(fget=lambda self: self.returnFileEntries(ftype='ghost'))
     requires = property(fget=lambda self: self.returnPrco('requires'))
+    strong_requires = property(fget=lambda self: self.returnPrco('strong_requires'))
     provides = property(fget=lambda self: self.returnPrco('provides'))
     obsoletes = property(fget=lambda self: self.returnPrco('obsoletes'))
     conflicts = property(fget=lambda self: self.returnPrco('conflicts'))
+    # weak_requires = property(fget=lambda self: self.returnPrco('recommends'))
+    # info_requires = property(fget=lambda self: self.returnPrco('suggests'))
     provides_names = property(fget=lambda self: self.returnPrcoNames('provides'))
     requires_names = property(fget=lambda self: self.returnPrcoNames('requires'))
+    strong_requires_names = property(fget=lambda self: self.returnPrcoNames('strong_requires'))
     conflicts_names = property(fget=lambda self: self.returnPrcoNames('conflicts'))
     obsoletes_names = property(fget=lambda self: self.returnPrcoNames('obsoletes'))
     provides_print = property(fget=lambda self: self.returnPrco('provides', True))
     requires_print = property(fget=lambda self: self.returnPrco('requires', True))
+    strong_requires_print = property(fget=lambda self: self.returnPrco('strong_requires', True))
     conflicts_print = property(fget=lambda self: self.returnPrco('conflicts', True))
     obsoletes_print = property(fget=lambda self: self.returnPrco('obsoletes', True))
     changelog = property(fget=lambda self: self.returnChangelog())
@@ -737,7 +807,7 @@ class YumAvailablePackage(PackageObject, RpmBase):
         """ This reports the repo the package is from, we integrate YUMDB info.
             for RPM packages so a package from "fedora" that is installed has a
             ui_from_repo of "@fedora". Note that, esp. with the --releasever
-            option, "fedora" or "rawhide" isn't authoritive.
+            option, "fedora" or "rawhide" isn't authoritative.
             So we also check against the current releasever and if it is
             different we also print the YUMDB releasever. This means that
             installing from F12 fedora, while running F12, would report as
@@ -789,7 +859,7 @@ class YumAvailablePackage(PackageObject, RpmBase):
 
     size = property(fget=lambda self: self._size())
     remote_path = property(_remote_path)
-    remote_url = property(_remote_url)
+    remote_url = property(lambda self: self._remote_url())
 
     def _committer(self):
         "Returns the name of the last person to do a commit to the changelog."
@@ -797,22 +867,14 @@ class YumAvailablePackage(PackageObject, RpmBase):
         if hasattr(self, '_committer_ret'):
             return self._committer_ret
 
-        def _nf2ascii(x):
-            """ does .encode("ascii", "replace") but it never fails. """
-            ret = []
-            for val in x:
-                if ord(val) >= 128:
-                    val = '?'
-                ret.append(val)
-            return "".join(ret)
-
         if not len(self.changelog): # Empty changelog is _possible_ I guess
             self._committer_ret = self.packager
             return self._committer_ret
         val = self.changelog[0][1]
         # Chagnelog data is in multiple locale's, so we convert to ascii
         # ignoring "bad" chars.
-        val = _nf2ascii(val)
+        val = misc.to_unicode(val, errors='replace')
+        val = val.encode('ascii', 'replace')
         # Hacky way to get rid of version numbers...
         ix = val.find('> ')
         if ix != -1:
@@ -859,7 +921,8 @@ class YumAvailablePackage(PackageObject, RpmBase):
         try:
             hdr = rpmUtils.miscutils.hdrFromPackage(ts, rpmfile)
         except rpmUtils.RpmUtilsError:
-            raise Errors.RepoError, 'Package Header %s: RPM Cannot open' % self
+            raise Errors.RepoError('Package Header %s: RPM Cannot open' % self,
+                                   repo=self.repo)
         return hdr
         
     def returnLocalHeader(self):
@@ -871,9 +934,11 @@ class YumAvailablePackage(PackageObject, RpmBase):
                 hlist = rpm.readHeaderListFromFile(self.localHdr())
                 hdr = hlist[0]
             except (rpm.error, IndexError):
-                raise Errors.RepoError, 'Package Header %s: Cannot open' % self
+                raise Errors.RepoError('Package Header %s: Cannot open' % self,
+                                       repo=self.repo)
         else:
-            raise Errors.RepoError, 'Package Header %s: Not Available' % self
+            raise Errors.RepoError('Package Header %s: Not Available' % self,
+                                   repo=self.repo)
 
         return hdr
 
@@ -1063,10 +1128,10 @@ class YumAvailablePackage(PackageObject, RpmBase):
         
         packager = url = ''
         if self.packager:
-            packager = misc.to_unicode(misc.to_xml(self.packager))
+            packager = misc.to_xml(self.packager)
         
         if self.url:
-            url = misc.to_unicode(misc.to_xml(self.url))
+            url = misc.to_xml(self.url)
         (csum_type, csum, csumid) = self.checksums[0]
         msg = """
   <name>%s</name>
@@ -1080,10 +1145,10 @@ class YumAvailablePackage(PackageObject, RpmBase):
   <time file="%s" build="%s"/>
   <size package="%s" installed="%s" archive="%s"/>\n""" % (self.name, 
          self.arch, self.epoch, self.ver, self.rel, csum_type, csum, 
-         misc.to_unicode(misc.to_xml(self.summary)), 
-         misc.to_unicode(misc.to_xml(self.description)), 
+         misc.to_xml(self.summary),
+         misc.to_xml(self.description),
          packager, url, self.filetime, 
-         self.buildtime, self.packagesize, self.size, self.archivesize)
+         self.buildtime, self.packagesize, self.installedsize, self.archivesize)
         
         msg += self._return_remote_location()
         return msg
@@ -1121,6 +1186,10 @@ class YumAvailablePackage(PackageObject, RpmBase):
         msg += self._dump_requires()
         msg += self._dump_pco('conflicts')         
         msg += self._dump_pco('obsoletes')         
+        msg += self._dump_pco('suggests')
+        msg += self._dump_pco('enhances')
+        msg += self._dump_pco('recommends')
+        msg += self._dump_pco('supplements')
         msg += self._dump_files(True)
         if msg[-1] != '\n':
             msg += """\n"""
@@ -1131,9 +1200,9 @@ class YumAvailablePackage(PackageObject, RpmBase):
     def _dump_pco(self, pcotype):
            
         msg = ""
-        mylist = getattr(self, pcotype)
+        mylist = self.returnPrco(pcotype)
         if mylist: msg = "\n    <rpm:%s>\n" % pcotype
-        for (name, flags, (e,v,r)) in mylist:
+        for (name, flags, (e,v,r)) in sorted(mylist):
             pcostring = '''      <rpm:entry name="%s"''' % misc.to_xml(name, attrib=True)
             if flags:
                 pcostring += ''' flags="%s"''' % misc.to_xml(flags, attrib=True)
@@ -1151,25 +1220,14 @@ class YumAvailablePackage(PackageObject, RpmBase):
         return msg
     
     def _dump_files(self, primary=False):
-        msg ="\n"
-        if not primary:
-            files = self.returnFileEntries('file')
-            dirs = self.returnFileEntries('dir')
-            ghosts = self.returnFileEntries('ghost')
-        else:
-            files = self.returnFileEntries('file', primary_only=True)
-            dirs = self.returnFileEntries('dir', primary_only=True)
-            ghosts = self.returnFileEntries('ghost', primary_only=True)
-                
-        for fn in files:
-            msg += """    <file>%s</file>\n""" % misc.to_xml(fn)
-        for fn in dirs:
-            msg += """    <file type="dir">%s</file>\n""" % misc.to_xml(fn)
-        for fn in ghosts:
-            msg += """    <file type="ghost">%s</file>\n""" % misc.to_xml(fn)
-        
-        return msg
-
+        msg = []
+        for fn in sorted(self.returnFileEntries('file', primary)):
+            msg.append('\n  <file>%s</file>' % misc.to_xml(fn))
+        for fn in sorted(self.returnFileEntries('dir', primary)):
+            msg.append('\n  <file type="dir">%s</file>' % misc.to_xml(fn))
+        for fn in sorted(self.returnFileEntries('ghost', primary)):
+            msg.append('\n  <file type="ghost">%s</file>' % misc.to_xml(fn))
+        return ''.join(msg)
 
     def _requires_with_pre(self):
         raise NotImplementedError()
@@ -1194,8 +1252,8 @@ class YumAvailablePackage(PackageObject, RpmBase):
                         continue
                     newlist.append(i)
                 mylist = newlist
-        
-        for (name, flags, (e,v,r),pre) in mylist:
+        used = 0
+        for (name, flags, (e,v,r),pre) in sorted(mylist):
             if name.startswith('rpmlib('):
                 continue
             # this drops out requires that the pkg provides for itself.
@@ -1217,19 +1275,22 @@ class YumAvailablePackage(PackageObject, RpmBase):
                     prcostring += ''' ver="%s"''' % misc.to_xml(v, attrib=True)
                 if r:
                     prcostring += ''' rel="%s"''' % misc.to_xml(r, attrib=True)
-            if pre:
+            if pre not in ("0", 0):
                 prcostring += ''' pre="%s"''' % pre
-                    
+
             prcostring += "/>\n"
             msg += prcostring
+            used += 1
             
         if mylist: msg += "    </rpm:requires>"
+        if used == 0:
+            return ""
         return msg
 
     def _dump_changelog(self, clog_limit):
         if not self.changelog:
             return ""
-        msg = "\n"
+        msg = []
         # We need to output them "backwards", so the oldest is first
         if not clog_limit:
             clogs = self.changelog
@@ -1244,34 +1305,46 @@ class YumAvailablePackage(PackageObject, RpmBase):
                 hack_ts += 1
             last_ts = ts
             ts += hack_ts
-            msg += """<changelog author="%s" date="%s">%s</changelog>\n""" % (
+            msg.append('\n  <changelog author="%s" date="%s">%s</changelog>' % (
                         misc.to_xml(author, attrib=True), misc.to_xml(str(ts)), 
-                        misc.to_xml(content))
-        return msg
+                        misc.to_xml(content)))
+        return ''.join(msg)
 
     def xml_dump_primary_metadata(self):
         msg = """\n<package type="rpm">"""
-        msg += misc.to_unicode(self._dump_base_items())
-        msg += misc.to_unicode(self._dump_format_items())
+        msg += self._dump_base_items()
+        msg += self._dump_format_items()
         msg += """\n</package>"""
-        return misc.to_utf8(msg)
+        assert type(msg) is str
+        return msg
 
     def xml_dump_filelists_metadata(self):
-        msg = """\n<package pkgid="%s" name="%s" arch="%s">
-    <version epoch="%s" ver="%s" rel="%s"/>\n""" % (self.checksum, self.name, 
-                                     self.arch, self.epoch, self.ver, self.rel)
-        msg += misc.to_unicode(self._dump_files())
-        msg += "</package>\n"
-        return misc.to_utf8(msg)
+        msg = """
+<package pkgid="%s" name="%s" arch="%s">
+  <version epoch="%s" ver="%s" rel="%s"/>%s
+</package>""" % (self.checksum, self.name, self.arch,
+                 self.epoch, self.ver, self.rel,
+                 self._dump_files())
+        assert type(msg) is str
+        return msg
 
     def xml_dump_other_metadata(self, clog_limit=0):
-        msg = """\n<package pkgid="%s" name="%s" arch="%s">
-    <version epoch="%s" ver="%s" rel="%s"/>\n""" % (self.checksum, self.name, 
-                                     self.arch, self.epoch, self.ver, self.rel)
-        msg += "%s\n</package>\n" % misc.to_unicode(self._dump_changelog(clog_limit))
-        return misc.to_utf8(msg)
-
+        msg = """
+<package pkgid="%s" name="%s" arch="%s">
+  <version epoch="%s" ver="%s" rel="%s"/>%s
+</package>""" % (self.checksum, self.name, self.arch,
+                 self.epoch, self.ver, self.rel,
+                 self._dump_changelog(clog_limit))
+        assert type(msg) is str
+        return msg
 
+# HACK: This is completely retarded. Don't blame me, someone just fix
+#       rpm-python already. This is almost certainly not all of the problems,
+#       but w/e.
+def _rpm_long_size_hack(hdr, size):
+    """ Rpm returns None, for certain sizes. And has a "longsize" for the real
+        values. """
+    return hdr[size] or hdr['long' + size]
 
 #  This is a tweak on YumAvailablePackage() and is a base class for packages
 # which are actual rpms.
@@ -1299,10 +1372,14 @@ class YumHeaderPackage(YumAvailablePackage):
         self.pkgid = self.hdr[rpm.RPMTAG_SHA1HEADER]
         if not self.pkgid:
             self.pkgid = "%s.%s" %(self.hdr['name'], self.hdr['buildtime'])
-        self.packagesize = self.hdr['size']
+        self.packagesize = _rpm_long_size_hack(self.hdr, 'archivesize')
+        self.installedsize = _rpm_long_size_hack(self.hdr, 'size')
         self.__mode_cache = {}
         self.__prcoPopulated = False
 
+    def _remote_url(self):
+        return 'file://' + urllib.quote(os.path.abspath(self.localPkg()))
+
     def _loadSummary(self):
         # Summaries "can be" empty, which rpm return [], see BZ 473239, *sigh*
         if self._loaded_summary is None:
@@ -1338,6 +1415,17 @@ class YumHeaderPackage(YumAvailablePackage):
     def _get_hdr(self):
         return self.hdr
 
+    def _filter_deps(self, name, flag, vers, andmask, resmask):
+        newname = []
+        newflag = []
+        newvers = []
+        for (n, f, v) in zip(name, flag, vers):
+            if f & andmask == resmask:
+                newname.append(n)
+                newflag.append(f)
+                newvers.append(v)
+        return (newname, newflag, newvers)
+
     def _populatePrco(self):
         "Populate the package object with the needed PRCO interface."
 
@@ -1345,6 +1433,17 @@ class YumHeaderPackage(YumAvailablePackage):
                      "CONFLICT": misc.share_data("conflicts"),
                      "REQUIRE":  misc.share_data("requires"),
                      "PROVIDE":  misc.share_data("provides") }
+
+        def _end_nfv(name, flag, vers):
+            flag = map(rpmUtils.miscutils.flagToString, flag)
+            flag = map(misc.share_data, flag)
+
+            vers = map(rpmUtils.miscutils.stringToVersion, vers)
+            vers = map(lambda x: (misc.share_data(x[0]), misc.share_data(x[1]),
+                                  misc.share_data(x[2])), vers)
+
+            return map(misc.share_data, zip(name,flag,vers))
+
         hdr = self._get_hdr()
         for tag in tag2prco:
             name = hdr[getattr(rpm, 'RPMTAG_%sNAME' % tag)]
@@ -1353,16 +1452,48 @@ class YumHeaderPackage(YumAvailablePackage):
                 continue
 
             lst = hdr[getattr(rpm, 'RPMTAG_%sFLAGS' % tag)]
-            flag = map(rpmUtils.miscutils.flagToString, lst)
-            flag = map(misc.share_data, flag)
-
-            lst = hdr[getattr(rpm, 'RPMTAG_%sVERSION' % tag)]
-            vers = map(rpmUtils.miscutils.stringToVersion, lst)
-            vers = map(lambda x: (misc.share_data(x[0]), misc.share_data(x[1]),
-                                  misc.share_data(x[2])), vers)
-
+            if tag == 'REQUIRE':
+                #  Rpm is a bit magic here, and if pkgA requires(pre/post): foo
+                # it will then let you remove foo _after_ pkgA has been
+                # installed. So we need to mark those deps. as "weak".
+                #  This is not the same as recommends/weak_requires.
+                bits = rpm.RPMSENSE_SCRIPT_PRE | rpm.RPMSENSE_SCRIPT_POST
+                weakreqs = [bool(flag & bits) for flag in lst]
+
+            vers = hdr[getattr(rpm, 'RPMTAG_%sVERSION' % tag)]
             prcotype = tag2prco[tag]
-            self.prco[prcotype] = map(misc.share_data, zip(name,flag,vers))
+            self.prco[prcotype] = _end_nfv(name, lst, vers)
+            if tag == 'REQUIRE':
+                weakreqs = zip(weakreqs, self.prco[prcotype])
+                strongreqs = [wreq[1] for wreq in weakreqs if not wreq[0]]
+                self.prco['strong_requires'] = strongreqs
+
+        # This looks horrific as we are supporting both the old and new formats:
+        tag2prco = { "SUGGEST":    ( misc.share_data("suggests"),
+                                     1156, 1157, 1158, 1 << 27, 0),
+                     "ENHANCE":    ( misc.share_data("enhances"),
+                                     1159, 1160, 1161, 1 << 27, 0),
+                     "RECOMMEND":  ( misc.share_data("recommends"),
+                                     1156, 1157, 1158, 1 << 27, 1 << 27),
+                     "SUPPLEMENT": ( misc.share_data("supplements"),
+                                     1159, 1160, 1161, 1 << 27, 1 << 27) }
+        for tag in tag2prco:
+            (prcotype, oldtagn, oldtagv, oldtagf, andmask, resmask) = tag2prco[tag]
+            name = None
+            if _rpm_has_new_weakdeps:
+                name = hdr[getattr(rpm, 'RPMTAG_%sNAME' % tag)]
+            if not name:
+                name = hdr[oldtagn]
+                if not name:
+                    continue
+                (name, flag, vers) = self._filter_deps(name, hdr[oldtagf], hdr[oldtagv], andmask, resmask)
+            else:
+                flag = hdr[getattr(rpm, 'RPMTAG_%sFLAGS' % tag)]
+                vers = hdr[getattr(rpm, 'RPMTAG_%sVERSION' % tag)]
+            name = map(misc.share_data, name)
+            if not name: # empty or none or whatever, doesn't matter
+                continue
+            self.prco[prcotype] = _end_nfv(name, flag, vers)
     
     def tagByName(self, tag):
         warnings.warn("tagByName() will go away in a furture version of Yum.\n",
@@ -1438,16 +1569,16 @@ class YumHeaderPackage(YumAvailablePackage):
         # then create a _loadChangelog() method to put them into the 
         # self._changelog attr
         if len(self.hdr['changelogname']) > 0:
-            return zip(misc.to_unicode(self.hdr['changelogtime'], errors='replace'),
-                       misc.to_unicode(self.hdr['changelogname'], errors='replace'),
-                       misc.to_unicode(self.hdr['changelogtext'], errors='replace'))
+            return zip(self.hdr['changelogtime'],
+                       self.hdr['changelogname'],
+                       self.hdr['changelogtext'])
         return []
 
     def returnChecksums(self):
         raise NotImplementedError()
 
     def _size(self):
-        return self.hdr['size']
+        return _rpm_long_size_hack(self.hdr, 'size')
 
     def _is_pre_req(self, flag):
         """check the flags for a requirement, return 1 or 0 whether or not requires
@@ -1708,6 +1839,7 @@ class YUMVerifyPackage:
         self._files = {}
 
 
+_last_fnmatch = {}
 class _RPMVerifyPackage(YUMVerifyPackage):
     def __init__(self, po, fi, def_csum_type, patterns, all):
         YUMVerifyPackage.__init__(self, po)
@@ -1720,18 +1852,30 @@ class _RPMVerifyPackage(YUMVerifyPackage):
         (fi, def_csum_type, patterns, all) = self._presetup
         del self._presetup
 
+        global _last_fnmatch
+        _this_fnmatch = {}
         for ft in fi:
             fn = ft[0]
             if patterns:
                 matched = False
                 for p in patterns:
-                    if fnmatch.fnmatch(fn, p):
+                    if p in _last_fnmatch:
+                        match = _last_fnmatch[p]
+                    elif p in _this_fnmatch:
+                        match = _this_fnmatch[p]
+                    else:
+                        match = misc.compile_pattern(p)
+                    _this_fnmatch[p] = match
+
+                    if match(fn):
                         matched = True
                         break
                 if not matched: 
                     continue
 
             self.add(_RPMVerifyPackageFile(fi, ft, def_csum_type, all))
+        if _this_fnmatch:
+            _last_fnmatch = _this_fnmatch
 
     def __contains__(self, *args, **kwargs):
         self._setup()
@@ -1763,7 +1907,8 @@ class YumInstalledPackage(YumHeaderPackage):
             self.yumdb_info = yumdb.get_package(self)
 
     def verify(self, patterns=[], deps=False, script=False,
-               fake_problems=True, all=False, fast=False, callback=None):
+               fake_problems=True, all=False, fast=False, callback=None,
+               failfast=False):
         """verify that the installed files match the packaged checksum
            optionally verify they match only if they are in the 'pattern' list
            returns a tuple """
@@ -1891,17 +2036,22 @@ class YumInstalledPackage(YumHeaderPackage):
                     problems.append(prob)
 
                 my_mode = my_st.st_mode
+                pf_mode = pf.mode
+                perm_mask = 0777
                 if 'ghost' in ftypes: #  This is what rpm does, although it
-                    my_mode &= 0777   # doesn't usually get here.
-                if check_perms and pf.verify_mode and my_mode != pf.mode:
+                    my_mode &= perm_mask   # doesn't usually get here.
+                    pf_mode &= perm_mask
+                if check_perms and pf.verify_mode and my_mode != pf_mode:
                     prob = _PkgVerifyProb('mode', 'mode does not match', ftypes)
-                    prob.database_value = pf.mode
+                    prob.database_value = pf_mode
                     prob.disk_value     = my_st.st_mode
                     problems.append(prob)
 
                 verify_digest = pf.verify_digest
                 if fast and not problems and (my_st_size == pf.size):
                     verify_digest = False
+                if failfast and problems:
+                    verify_digest = False
                 if not pf.digest:
                     verify_digest = False
 
@@ -1946,7 +2096,7 @@ class YumInstalledPackage(YumHeaderPackage):
                             my_csum = digest_type + ':' + my_csum
                             my_st_size = fp.read_size
 
-                    if pf.verify_digest and my_csum != csum:
+                    if pf.verify_digest and my_csum != csum and my_csum:
                         prob = _PkgVerifyProb('checksum',
                                               'checksum does not match', ftypes)
                         prob.database_value = csum
@@ -2120,11 +2270,11 @@ class YumLocalPackage(YumHeaderPackage):
             relpath = self.localpath
 
         if self._baseurl:
-            msg = """<location xml:base="%s" href="%s"/>\n""" % (
+            msg = """  <location xml:base="%s" href="%s"/>\n""" % (
                                      misc.to_xml(self._baseurl, attrib=True),
                                      misc.to_xml(relpath, attrib=True))
         else:
-            msg = """<location href="%s"/>\n""" % misc.to_xml(relpath, attrib=True)
+            msg = """  <location href="%s"/>\n""" % misc.to_xml(relpath, attrib=True)
 
         return msg
 
